Require Import connectives.
Parameter eq : forall (A:Type), A -> A -> Prop.
Axiom refl : forall A, forall (x:A), eq (A) x x.
Axiom eq_ind : forall A, forall (x:A), forall (P:(A -> Prop)), (P x) -> forall (y:A), (eq (A) x y) -> P y.
Definition rewrite_l : forall A, forall (x:A), forall (P:(A -> Prop)), (P x) -> forall (y:A), (eq (A) x y) -> P y := fun (A:Type) => fun (x:A) => fun (P:A -> Prop) => fun (Hx:P x) => (fun (y:A) => fun (Heq:eq (A) x y) => (((((((eq_ind) (A)) (x)) (fun (__:A) => P __)) (Hx)) (y)) (Heq))).
Definition eq_coerc : forall (A:Prop), forall (B:Prop), A -> (eq (Prop) A B) -> B := fun (A:Prop) => fun (B:Prop) => fun (Ha:A) => (fun (Heq:eq (Prop) A B) => (((((((eq_ind) (Prop)) (A)) (fun (x_19:Prop) => x_19)) (Ha)) (B)) (Heq))).
Definition absurd : forall (A:Prop), A -> (connectives.Not A) -> connectives.False := fun (A:Prop) => fun (H:A) => (fun (Hn:connectives.Not A) => (((((connectives.Not_ind) (A)) (connectives.False)) (fun (_x_80:A -> connectives.False) => ((_x_80) (H)))) (Hn))).
